# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/3/13
import argparse
import os
import sys
import time
sys.path.append(os.getcwd())
from common.common import Common
from xiaoniangao.xiaoniangao_follow.xiaoniangao_follow import XiaoniangaoFollow


def main(log_type, crawler, strategy, oss_endpoint, env, machine):
    while True:
        try:
            Common.logger(log_type, crawler).info('开始抓取 小年糕 定向榜\n')
            XiaoniangaoFollow.get_follow_videos(log_type=log_type,
                                                crawler=crawler,
                                                strategy=strategy,
                                                oss_endpoint=oss_endpoint,
                                                env=env,
                                                machine=machine)
            Common.del_logs(log_type, crawler)
            Common.logger(log_type, crawler).info('抓取完一轮，休眠 1 分钟\n')
            time.sleep(60)
        except Exception as e:
            Common.logger(log_type, crawler).info(f"小年糕定向抓取异常:{e}\n")
            # Feishu.bot(log_type, crawler, f"{e}")


if __name__ == "__main__":
    parser = argparse.ArgumentParser()  ## 新建参数解释器对象
    parser.add_argument('--log_type', type=str)  ## 添加参数,注明参数类型
    parser.add_argument('--crawler')  ## 添加参数
    parser.add_argument('--strategy')  ## 添加参数
    parser.add_argument('--oss_endpoint')  ## 添加参数
    parser.add_argument('--env')  ## 添加参数
    parser.add_argument('--machine')  ## 添加参数
    args = parser.parse_args()  ### 参数赋值，也可以通过终端赋值
    main(log_type=args.log_type,
         crawler=args.crawler,
         strategy=args.strategy,
         oss_endpoint=args.oss_endpoint,
         env=args.env,
         machine=args.machine)